{$M 6000, 600, 600}
{$V-,I-,R-,F+}
Program ScreenSave;

Uses  CRT, DOS, VIDEO, TSRU;

Const
  { Program's signature. }
  TSR_tmark : string[20] = 'MEMPHIS';

Var
  { Interrupt number for the TSR's communication interrupt. }
  TSR_int : Byte;
  TSR_AX : Word;

(****************************************************************)
{ This procedure contains your pop-up routine.  When you want to
  create a new pop-up program, you only need to change this
  porcedure.                                                     }
(****************************************************************)

Procedure Do_Pop;
Var
  sc : screens;
  fn : string;
  f : text;
  i,j : byte;

Label EndProc;

Begin
ReadScr(sc);
sc.x := wherex;
sc.y := wherey;
clrscr;
write('Name of file to store screen:  ');
readln(fn);
If fn = '' Then
  GoTo EndProc;

Assign(f,fn);
Rewrite(f);
If IOresult <> 0 Then
  begin
  For i := 1 To Length(fn) Do
    fn[i] := UpCase(fn[i]);
  WriteLn('Could not open file "',fn,'".  Press RETURN.');
  ReadLn;
  GoTo EndProc;
  end;
For i := 1 To 25 Do
  begin
  for j := 1 To 80 Do
    write(f,sc.position[i,j].ch);
  end;
close(f);

EndProc:

WriteScr(sc);
With sc Do
  gotoxy(x,y);
End;

(****************************************************************)

Procedure MyPopRtn;
Var
  R : Registers;

Begin
BeginPop;
do_pop;
EndPop;
End;

(****************************************************************)

Procedure stop_TSR;
Begin
If TSRExit Then
  WriteLn('SCRSAVE stopped.')
Else
  WriteLn('Unable to stop SCRSAVE - other TSR has been installed.');
End;

(****************************************************************)
{ This interrupt is installed at program start-up.  Its purpose
  is to provide a way to communicate with an installed copy of
  the TSR program through command line parameters.  The
  installation of this ;interrupt serves to prevent any attempt
  to install a second copy of the same TSR program               }
(****************************************************************)

Procedure TSR_IntRtn(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP: Word);
  Interrupt;
Begin
TSR_AX := AX;
CLI;
BeginInt;
STI;

  Case TSR_AX Of
  1:
    Begin
    stop_TSR;
    End;

  2:
    Begin
    TSROFF := TRUE;
    WriteLn('SCRSAVE suspended.');
    End;

  3:
    Begin
    TSROFF := FALSE;
    WriteLn('SCRSAVE restarted.');
    End;
  End;

CLI;
EndInt;
STI;
End;

(****************************************************************)

Var
  i  : Byte;
  r  : Registers;
  st : String;
  b  : Boolean;

Begin

{ Check to see if TSR is already installed }

TSR_int := DupCheck( TSR_tmark, @TSR_intrtn);

{ If it is already installed, check for parameter. }

If TSR_int > 0 Then
  begin
  TextColor(10);
  If ParamCount > 0 Then
    begin
    st := ParamStr(1);
    For i := 1 To Length(st) Do
      st[i] := UpCase(st[i]);

    If (st = 'STOP') Or (st = 'END') Or (st = 'QUIT') Or (st = 'REMOVE') Then
      r.AX := 1
    Else If (st = 'HOLD') Or (st = 'PAUSE') Or (st = 'WAIT') Then
      r.AX := 2
    Else If (st = 'RSTR') Or (st = 'RESTART') Or (st = 'CONTINUE') Or (st = 'RESUME') Then
      r.AX := 3
    Else r.AX := 4;

    If r.AX < 4 Then
      begin
      Intr( TSR_int, r);
      Exit;
      end
    Else
      begin
      WriteLn('SCRSAVE: invalid parameter ',paramstr(1));
      WriteLn('Syntax : SCRSAVE [stop] [hold] [rstr]  ');
      Exit;
      end;
    end
  Else
    WriteLn('SCRSAVE already installed.');
  Exit;
  End;

PopSetup(@MyPoprtn,82,$08);

ClrScr;
TextColor(15);
TextBackground(1);
WriteLn('ͻ');
WriteLn('            Memory-Resident Screen Saver Here!            ');
WriteLn('ͼ');
TextColor(10);
TextBackground(0);
WriteLn('Press <ALT> and the numeric keypad <0> key to activate');

WriteLn;
WriteLn('Enter "SCRSAVE stop" to remove Screen Saver from memory');
WriteLn('      "SCRSAVE hold" to temporarily halt Screen Saver  ');
WriteLn('      "SCRSAVE rstr" to restart Screen Saver           ');
stacksw := -1;
install_int;
Keep(0);
End.
